function determineMode() {
    //Mode numbers are defined in pageModes.constant.js as mode IDs. This is injected so cannot import here.
    var DYNAMICS_ACCOUNT_ENTITY_INFO = {
        name : "account",
        modeNum: 22
    };
    var DYNAMICS_LEAD_ENTITY_INFO = {
        name : "lead",
        modeNum: 20
    };
    var DYNAMICS_CONTACT_ENTITY_INFO = {
        name: "contact",
        modeNum: 21
    };

    var DYNAMICS_GENERIC_MODE_NUM = 5;
    var _tempElmtId = "_hidChromeExt_modeAttr_";

    var _contentWindow = document.getElementById('contentIFrame0');
    var xrmFound = false;
    var _contentWindowXrm = null
    if (_contentWindow) {
        _contentWindowXrm = _contentWindow.contentWindow.Xrm;
        if (!_contentWindowXrm || !_contentWindowXrm.Page || _contentWindowXrm.Page.data == null) {
            _contentWindow = document.getElementById('contentIFrame1');
        }
        else {
            xrmFound = true;
        }

        if (_contentWindow && !xrmFound) {
            _contentWindowXrm = _contentWindow.contentWindow.Xrm;
            if (_contentWindowXrm && _contentWindowXrm.Page && _contentWindowXrm.Page.data != null) {
                xrmFound = true;
            }
        }
    }
    else {
        if (!_contentWindowXrm || !_contentWindowXrm.Page || _contentWindowXrm.Page.data == null) {

            let listOfIframes = document.getElementsByTagName('iframe');
            if (listOfIframes) {
                for (index = 0 ; index < listOfIframes.length ; index++ ) {
                    const nameOfIframe = listOfIframes[index].getAttribute('id');
                    if (nameOfIframe && nameOfIframe.includes('ClientApiFrame') && !isNaN(nameOfIframe.substring(nameOfIframe.indexOf('_') + 1))) {
                        _contentWindow = listOfIframes[index];
                        _contentWindowXrm = listOfIframes[index].contentWindow.Xrm;
                    }
                }
                if (_contentWindowXrm && _contentWindowXrm.Page && _contentWindowXrm.Page.data != null) {
                    xrmFound = true;
                }
            }
        }
    }
    if (_contentWindowXrm && _contentWindowXrm.Page && _contentWindowXrm.Page.data !== null) {
        xrmFound = true;
    }

    var determinedMode;
    if (xrmFound) {
        console.log("contentWindowXrm.Page.data.entityName is :: ", _contentWindowXrm.Page.data.entity.getEntityName());

        switch(_contentWindowXrm.Page.data.entity.getEntityName()) {
            case DYNAMICS_LEAD_ENTITY_INFO.name :
                determinedMode = DYNAMICS_LEAD_ENTITY_INFO.modeNum;
                break;
            case DYNAMICS_ACCOUNT_ENTITY_INFO.name :
                determinedMode = DYNAMICS_ACCOUNT_ENTITY_INFO.modeNum;
                break;
            case DYNAMICS_CONTACT_ENTITY_INFO.name :
                determinedMode = DYNAMICS_CONTACT_ENTITY_INFO.modeNum;
                break;
            default:
                determinedMode = DYNAMICS_GENERIC_MODE_NUM;
        }
    }
    else {
        console.log("xrmData not found in getDynamicsMode.js");
        determinedMode = DYNAMICS_GENERIC_MODE_NUM;
    }

    if (document.getElementById(_tempElmtId) != null) {
        document.getElementById(_tempElmtId).remove();
    }

    var input = null;
    input = document.createElement("input");
    input.id = _tempElmtId;
    input.setAttribute("type", "hidden");
    input.setAttribute("value", determinedMode);
    document.body.appendChild(input);
}

function getDynamicsMode() {
    let scriptContent = "";
    let script = document.createElement('script');
    let functionStr = determineMode.toString();
    const tempElmtIdDynamicsMode = "_hidChromeExt_modeAttr_";
    scriptContent += functionStr.slice(functionStr.indexOf("{") + 1, functionStr.lastIndexOf("}"));
    script.id = 'tmpDetermineModeScript';
    script.appendChild(document.createTextNode(scriptContent));
    (document.body || document.head || document.documentElement).appendChild(script);
    const modeNum= document.getElementById(tempElmtIdDynamicsMode).value;
    document.getElementById("tmpDetermineModeScript").remove();
    return parseInt(modeNum);
}

getDynamicsMode();
