function getAttributesList() {
    var _contentWindowXrmAttr = null;
    var _contentWindowAttr = null;
    if (! _contentWindowAttr || ! _contentWindowXrmAttr || !_contentWindowXrmAttr.Page || _contentWindowXrmAttr.Page.data == null) {
        _contentWindowAttr = document.getElementById('contentIFrame0');
        _contentWindowXrmAttr = _contentWindowAttr  && _contentWindowAttr.contentWindow ? _contentWindowAttr.contentWindow.Xrm : null;
    }


    if (!_contentWindowXrmAttr || !_contentWindowXrmAttr.Page || _contentWindowXrmAttr.Page.data == null) {
        _contentWindowAttr = document.getElementById('contentIFrame1');
        if (_contentWindow) {
            _contentWindowXrmAttr = _contentWindowAttr  && _contentWindowAttr.contentWindow ? _contentWindowAttr.contentWindow.Xrm : null;
        }
    }
    if (!_contentWindowXrmAttr || !_contentWindowXrmAttr.Page || _contentWindowXrmAttr.Page.data == null) {
        let listOfIframes = document.getElementsByTagName('iframe');
        if (listOfIframes) {
            for (index = 0 ; index < listOfIframes.length ; index++ ) {
                const nameOfIframe = listOfIframes[index].getAttribute('id');
                if (nameOfIframe && nameOfIframe.includes('ClientApiFrame') && !isNaN(nameOfIframe.substring(nameOfIframe.indexOf('_') + 1))) {
                    _contentWindowXrmAttr = listOfIframes[index] && listOfIframes[index].contentWindow ? listOfIframes[index].contentWindow.Xrm: null;
                }
            }
        }
    }
    if (!_contentWindowXrmAttr || !_contentWindowXrmAttr.Page || _contentWindowXrmAttr.Page.data == null) {
        console.log("Dynamics CRM Extension Error: Cannot find Xrm object");
    }
    // _contentWindowXrm.Page.data.refresh(); // some times we have to reload the xrm.
    var attributeList = new Array();
    _contentWindowXrmAttr.Page.data.entity.attributes.forEach(function () {
        var attribute = arguments[0];
        var attrValue = {};
        var val = null;
        if (attribute.getAttributeType() == "lookup" && attribute.getValue() !== null)
            val = attribute.getValue()[0].name;
        else if (attribute.getAttributeType() == "optionset" && attribute.getValue() !== null)
            val = "Text: " + attribute.getText() + "\nValue: " + attribute.getValue();
        else if (attribute.getAttributeType() == "datetime" && attribute.getValue() !== null)
            val = attribute.getValue().toLocaleString();
        else
            val = attribute.getValue();
        attrValue.Name = attribute.getName();
        attrValue.Value = val;
        attrValue.isDirty = attribute.getIsDirty();
        attrValue.Type = attribute.getAttributeType();
        attrValue.Label = attribute.controls.getFirst(function () {
            return true;
        }).getLabel();

        attributeList.push(attrValue);
        attributeList.sort(function (a, b) {
            if (a.Name > b.Name) return 1; else if (a.Name == b.Name) return 0; else return -1
        });
    });

    if (document.getElementById("_hidChromeExt_attr_") != null)
        document.getElementById("_hidChromeExt_attr_").remove();

    var input = null;
    if (document.getElementById("_hidChromeExt_attr_") != null)
        input = document.getElementById("_hidChromeExt_attr_")
    else {
        input = document.createElement("input");
        input.id = "_hidChromeExt_attr_";
        input.setAttribute("type", "hidden");
    }
    var id = _contentWindowXrmAttr.Page.data.entity.getId();
    var name = _contentWindowXrmAttr.Page.data.entity.getEntityName();
    id = id.slice(id.indexOf("{") + 1, id.lastIndexOf("}"));
    attributeList.push({'Name': 'entitytype', 'Value': name});
    attributeList.push({'Name': 'id', 'Value': id});
    input.id = "_hidChromeExt_attr_";
    input.setAttribute("type", "hidden");
    input.setAttribute("value", JSON.stringify(attributeList));
    document.body.appendChild(input);
}

function retrieveWindowVariables() {
    var ret = {};
    var scriptContent = "";
    var script = document.createElement('script');
    var functionStr = getAttributesList.toString();
    scriptContent += functionStr.slice(functionStr.indexOf("{") + 1, functionStr.lastIndexOf("}"));
    script.id = 'tmpScript';
    script.appendChild(document.createTextNode(scriptContent));
    (document.body || document.head || document.documentElement).appendChild(script);
    ret = document.getElementById("_hidChromeExt_attr_").value;
    document.getElementById("tmpScript").remove();

    return ret;
}

JSON.parse(retrieveWindowVariables());
